<?php
/**
 * @copyright	Copyright (C) 2005 - 2012 Henk von Pickartz
 * @license		GNU General Public License version 2 or later
 * SimpleCaddy Tax plugin for SimpleCaddy 2.0.4 for Joomla 2.5+
 */

// No direct access.
defined('_JEXEC') or die;
require_once (JPATH_ROOT.DS.'components'.DS.'com_simplecaddy'.DS.'simplecaddy.class.php'); // mandatory

/** 
 * configuration class 
 */

class sctaxconfiguration extends JTable { // this is the standard configuration class for the plugin
// naming is {pluginname}configuration
	var $id;
	var $baserate;
	var $controlfield;
	var $tax_prodcode;
	var $rates;

	function sctaxconfiguration() { // initialise class and check if data table exists. If not, create it
		// Load plugin language, since we use it in the backend, standard language loading is NOT performed
		$lang = JFactory::getLanguage();
		$lang->load('plg_content_sctax', JPATH_ADMINISTRATOR);
		$db	= JFactory::getDBO();
		// next 2 lines: suppress any legitimate errors on checking if the table exists
	   	@$this->__construct( '#__sc_tax', 'id', $db );
		if (@count($db->getTableColumns($this->_tbl))==0 ) {
			// no columns found, so we need to create the table
			$query= "CREATE TABLE `#__sc_tax` (
			`id`  int NULL AUTO_INCREMENT ,
			`baserate`  float NULL ,
			`controlfield`  varchar(32) NULL ,
			`shipcontrolfield`  varchar(32) NULL ,
			`tax_prodcode`  varchar(32) NULL ,
			`rates`  text NULL ,
			PRIMARY KEY (`id`)
			)
			;";
			$this->_db->setQuery($query);
			$this->_db->query();
		};
		// get the first and only useful record in the db here
		$query="select `id` from `$this->_tbl` ";
		$this->_db->setQuery($query);
		$id=$this->_db->loadResult(); // this sets the first ID as the one to use.
		$this->load($id); // load the first id
	}
	
	function _showconfig() { // mandatory function name
		$lang = JFactory::getLanguage(); // joomla's backend does not load frontend languages by itself
		$extension = 'plg_content_sctax1'; // so we need to do this manually here
		$lang->load($extension);

		require_once(JPATH_COMPONENT_SITE."/simplecaddy.class.php");
		$fields=new fields();
		$fieldlist=$fields->getFieldNames(); // get all the fields, standard and custom
		$this->load();
		display::header(); // while this would be better inside the display function, a plugin does not have access to this
		JToolBarHelper::title( JText::_( "SCTAX_RATES" ), 'generic.png');
		JToolbarHelper::custom("save", "save", "", JText::_("SCTAX_SAVE"), false); 
		JToolbarHelper::cancel(); 
		?>
		<form name="adminForm">
			<table class="adminform">
				<tr><td style="width: 150px;"><?php echo JText::_("SCTAX_BASERATE");?></td><td><input type="text" name="baserate" value="<?php echo $this->baserate; ?>" size="5" /> %</td></tr> 
				<tr><td style="width: 150px;"><?php echo JText::_("SCTAX_CONTROLFIELD");?></td><td>
				<select name="controlfield">
				<?php 
					foreach ($fieldlist as $key=>$f) {
						echo "<option value='$f'".($f==$this->controlfield?" selected":"").">$f</option>";
					}
				?>
				</select>
				</td></tr> 
				<tr><td style="width: 150px;"><?php echo JText::_("SCTAX_SHIPCONTROLFIELD");?></td><td>
				<select name="shipcontrolfield">
				<?php 
					foreach ($fieldlist as $key=>$f) {
						echo "<option value='$f'".($f==$this->shipcontrolfield?" selected":"").">$f</option>";
					}
				?>
				</select>
				</td></tr> 

				<tr><td style="width: 150px;"><?php echo JText::_("SCTAX_TAXRATES");?></td><td>
				<textarea name="rates" cols="50" rows="10"><?php echo trim($this->rates); ?></textarea>
				</td></tr> 
				<tr><td style="width: 150px;"><?php echo JText::_("SCTAX_TAXPRODUCTCODE");?></td><td><input type="text" name="tax_prodcode" value="<?php echo $this->tax_prodcode; ?>" /></td></tr> 
				<input type="hidden" name="option" value="com_simplecaddy" />
				<input type="hidden" name="action" value="pluginconfig"/>
				<input type="hidden" name="pluginname" value="sctax"/>
				<input type="hidden" name="task" />
				<input type="hidden" name="id" value="<?php echo $this->id;?>"/>
			</table>
		</form>
		<?php
	}
	
	function save($stay=false, $orderingFilter = '', $ignore = '') { // mandatory function to save any variables
		$this->bind($_REQUEST); // get all the fields from the admin form
		$this->rates=trim($this->rates);
		$this->store(); // store the relevant fields only
		$msg=JText::_("SCTAX_CONFIG_SAVED");
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=plugins&task=show", $msg);
	}
	
	function cancel() {
		$mainframe=JFactory::getApplication();
		$mainframe->redirect("index.php?option=com_simplecaddy&action=plugins&task=show");
	}

}

/**
 * Sctax plugin joomla standard part
 */
class plgContentSctax extends JPlugin { // the Sctax part needs to be changed to the name of your plugin
	var $_plugin_number	= 0; // plugin counter -- see below

	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	public function _setPluginNumber() {
		$this->_plugin_number = (int)$this->_plugin_number + 1;
	}

	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		$view=JRequest::getVar("view");
		// check if we are displaying standard content. If not, get outta here
		$canProceed = ( ($context == 'com_content.article') and ($view=="article") );
		if (!$canProceed) {
			return;
		}

		// get parameters of the plugin set in admin
		$baserate= $this->params->get('baserate'); 
		
        // find the plugin code in the article text
		$regex = '/{(sctax)\s*(.*?)}/i'; // modify to the real name of your plugin
        $matches = array();
        preg_match_all( $regex, $article->text, $matches, PREG_SET_ORDER );

		// parse the command line into usable pieces
        $parms=array();
        foreach ($matches as $match) {
 			$this->_setPluginNumber();
			if ($this->_plugin_number==1) { // Example: get the stylesheet only ONCE per page, independently of the number of plugins on the page
				JHTML::stylesheet('sctax1.css','plugins/content/Sctax/css/');
				// on windows servers this may need to be changed to 
				// JHTML::stylesheet('Sctax.css','plugins\content\Sctax\css\' );
 			}

 			// the following will try to clean up any plugin command line
			$line=str_replace("&nbsp;", " ", $match[2]); // replace any html spaces with normal ones
            $line=str_replace(" ", "&", $line); // now change all the spaces to &
            $line=strtolower($line); // transform everything to lowercase so that won't bother anyone
			$line=strip_tags($line); // make sure there is no html like <span> tags left in the line due to TinyMCE or other editors inserting html
			
            parse_str( $line, $parms ); // use an integrated php function to transform the url string into an array of parameters

            if (!isset($parms['type'])) { // no type provided, probably just forgot...
            	$parms["type"]="notincluded"; // set it to the default type to make sure
            }

        	// get or define all different types of display we support
        	switch (strtolower($parms['type']) ) {
       			case "notincluded": // the default, if nothing has been provided
                	$html=$this->_shownotincluded($parms);
                	break;
        		default: // anything else provides an error message but should not crash the plugin or joomla!
                	$html=JText::_("SK_THIS_PLUGIN_TYPE_NOT_SUPPORTED"). " ({$parms['type']})";
        	}
            $article->text = preg_replace($regex, $html, $article->text, 1);
        }
        return false;
	}
	
	protected function _shownotincluded($commandline=array())	{
		$html="";
		$input=new JInput();
		$ordercode=$input->get("data"); // the data contains the ordercode when you finish the details page
		$orders=new orders(); 
		$orderid=$orders->getOrderIdFromCart($ordercode); // now we have an order ID
		$order= new order();
		$order->load($orderid);
		$cfields=unserialize($order->customfields); // returns an array with all fields

		$taxcfg=new sctaxconfiguration();
		if ( (strtolower(@$cfields['useshipping'])=="no") or (!@isset($cfields['useshipping'])) ) {
			$controlfield=$taxcfg->controlfield;
		}
		else
		{
			$controlfield=$taxcfg->shipcontrolfield;
		}

		$taxprod=$taxcfg->tax_prodcode;
		$staxdef=$taxcfg->rates;
		$ataxdef=explode("\r\n", $staxdef);
		$orderdestination=$cfields[$controlfield]; // get the destination from the fields by $controlfield
		if ($taxprod != "") {
			$tmp=new products();
			$sp=$tmp->getproductByProdCode($taxprod);
			$cartProd=new CartProduct();
			$cartProd->option="";
			$cartProd->prodcode=$taxprod;
			$cartProd->prodname=$sp->shorttext;
			$cartProd->unitprice=$sp->unitprice;
			$cartProd->quantity=1;
			$cartProd->finalprice=$sp->unitprice; // left on 0 for no discount for starters
			$cartProd->md5id=uniqid("T");
			$cart2=new cart2();
			$cart2->removecartProduct($cartProd); // remove eventual taxes from the cart first
			$c=$cart2->readcart();
			$exclude=array("shipping");
			$total=$cart2->getCartTotal($exclude);
			foreach ($ataxdef as $key=>$def) {
				list ($destination, $taxrate) = explode(":", $def);
				if (strtolower($destination) == strtolower($orderdestination) ) { // does this destination pay tax ?
					$taxamount= $total * ($taxrate/100);
					$cartProd->prodname=$sp->shorttext . " $taxrate %" ;
					$cartProd->finalprice = $taxamount;
					if (count($c)>0) { // make sure we have something in the cart
						$cart2->addCartProduct($cartProd);
					}
					// now update the order if this was a saved order
					if (@$ordercode<>"") { // we are dealing with a saved order
			    		$odet=new orderdetail();
			    		$id=$odet->isinorder($orderid, $cartProd->prodcode);
			    		$odet->orderid=$orderid;
			    		$odet->prodcode=$cartProd->prodcode;
			    		$odet->qty=1;
			    		$odet->unitprice=$taxamount;
			    		$odet->total=$taxamount;
			    		$odet->shorttext=$cartProd->prodname;
			    		$odet->option=$cartProd->option;
			            $odet->store();
			    		$gtotal=$order->total+$odet->total;
						$o = new order(); // reload the order
				        $o->load($orderid);
				    	$o->tax=$odet->total; // update the tax
				        $o->store(); // store the order with new total
					}
				}
			}
		}
		return $html;
	}
	
	
}